var CHANGE_THEME_REQUEST = '@bootstrap-styled/saga/CHANGE_THEME_REQUEST';
var CHANGE_THEME_FAILURE = '@bootstrap-styled/saga/CHANGE_THEME_FAILURE';
var DELETE_ASYNC_THEMES = '@bootstrap-styled/saga/DELETE_ASYNC_THEMES';
var STORE_ASYNC_THEME = '@bootstrap-styled/saga/STORE_ASYNC_THEME';

var changeThemeRequest = function changeThemeRequest(name) {
  return {
    type: CHANGE_THEME_REQUEST,
    name: name
  };
};
var changeThemeFailure = function changeThemeFailure(current, error) {
  return {
    type: CHANGE_THEME_FAILURE,
    error: error,
    current: current
  };
};
var storeAsyncTheme = function storeAsyncTheme(theme) {
  return {
    type: STORE_ASYNC_THEME,
    theme: theme
  };
};
var deleteAsyncThemes = function deleteAsyncThemes() {
  return {
    type: DELETE_ASYNC_THEMES
  };
};

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };
var sym = function sym(id) {
  return '@@redux-saga/' + id;
};
var TASK =              sym('TASK');
var HELPER =              sym('HELPER');
function check(value, predicate, error) {
  if (!predicate(value)) {
    log('error', 'uncaught at check', error);
    throw new Error(error);
  }
}
var hasOwnProperty = Object.prototype.hasOwnProperty;
function hasOwn(object, property) {
  return is.notUndef(object) && hasOwnProperty.call(object, property);
}
var is = {
  undef: function undef(v) {
    return v === null || v === undefined;
  },
  notUndef: function notUndef(v) {
    return v !== null && v !== undefined;
  },
  func: function func(f) {
    return typeof f === 'function';
  },
  number: function number(n) {
    return typeof n === 'number';
  },
  string: function string(s) {
    return typeof s === 'string';
  },
  array: Array.isArray,
  object: function object(obj) {
    return obj && !is.array(obj) && (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object';
  },
  promise: function promise(p) {
    return p && is.func(p.then);
  },
  iterator: function iterator(it) {
    return it && is.func(it.next) && is.func(it.throw);
  },
  iterable: function iterable(it) {
    return it && is.func(Symbol) ? is.func(it[Symbol.iterator]) : is.array(it);
  },
  task: function task(t) {
    return t && t[TASK];
  },
  observable: function observable(ob) {
    return ob && is.func(ob.subscribe);
  },
  buffer: function buffer(buf) {
    return buf && is.func(buf.isEmpty) && is.func(buf.take) && is.func(buf.put);
  },
  pattern: function pattern(pat) {
    return pat && (is.string(pat) || (typeof pat === 'undefined' ? 'undefined' : _typeof(pat)) === 'symbol' || is.func(pat) || is.array(pat));
  },
  channel: function channel(ch) {
    return ch && is.func(ch.take) && is.func(ch.close);
  },
  helper: function helper(it) {
    return it && it[HELPER];
  },
  stringableFunc: function stringableFunc(f) {
    return is.func(f) && hasOwn(f, 'toString');
  }
};
function log(level, message) {
  var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  if (typeof window === 'undefined') {
    console.log('redux-saga ' + level + ': ' + message + '\n' + (error && error.stack || error));
  } else {
    console[level](message, error);
  }
}
function deprecate(fn, deprecationWarning) {
  return function () {
    log('warn', deprecationWarning);
    return fn.apply(undefined, arguments);
  };
}
var updateIncentive = function updateIncentive(deprecated, preferred) {
  return deprecated + ' has been deprecated in favor of ' + preferred + ', please update your code';
};

var IO =              sym('IO');
var PUT = 'PUT';
var CALL = 'CALL';
var effect = function effect(type, payload) {
  var _ref;
  return _ref = {}, _ref[IO] = true, _ref[type] = payload, _ref;
};
function put(channel, action) {
  if (arguments.length > 1) {
    check(channel, is.notUndef, 'put(channel, action): argument channel is undefined');
    check(channel, is.channel, 'put(channel, action): argument ' + channel + ' is not a valid channel');
    check(action, is.notUndef, 'put(channel, action): argument action is undefined');
  } else {
    check(channel, is.notUndef, 'put(action): argument action is undefined');
    action = channel;
    channel = null;
  }
  return effect(PUT, { channel: channel, action: action });
}
put.resolve = function () {
  var eff = put.apply(undefined, arguments);
  eff[PUT].resolve = true;
  return eff;
};
put.sync =              deprecate(put.resolve,              updateIncentive('put.sync', 'put.resolve'));
function getFnCallDesc(meth, fn, args) {
  check(fn, is.notUndef, meth + ': argument fn is undefined');
  var context = null;
  if (is.array(fn)) {
    var _fn = fn;
    context = _fn[0];
    fn = _fn[1];
  } else if (fn.fn) {
    var _fn2 = fn;
    context = _fn2.context;
    fn = _fn2.fn;
  }
  if (context && is.string(fn) && is.func(context[fn])) {
    fn = context[fn];
  }
  check(fn, is.func, meth + ': argument ' + fn + ' is not a function');
  return { context: context, fn: fn, args: args };
}
function call(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  return effect(CALL, getFnCallDesc('call', fn, args));
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var constants = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
var CHANGE_THEME = exports.CHANGE_THEME = '@bootstrap-styled-redux/CHANGE_THEME';
var STORE_THEME = exports.STORE_THEME = '@bootstrap-styled-redux/STORE_THEME';
var DELETE_THEME = exports.DELETE_THEME = '@bootstrap-styled-redux/DELETE_THEME';
var DELETE_THEMES = exports.DELETE_THEMES = '@bootstrap-styled-redux/DELETE_THEMES';
});
unwrapExports(constants);
var constants_1 = constants.CHANGE_THEME;
var constants_2 = constants.STORE_THEME;
var constants_3 = constants.DELETE_THEME;
var constants_4 = constants.DELETE_THEMES;

var actions = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteThemes = exports.deleteTheme = exports.storeTheme = exports.changeTheme = undefined;
var changeTheme = exports.changeTheme = function changeTheme(theme) {
  return {
    type: constants.CHANGE_THEME,
    theme: theme
  };
};
var storeTheme = exports.storeTheme = function storeTheme(theme) {
  return {
    type: constants.STORE_THEME,
    theme: theme
  };
};
var deleteTheme = exports.deleteTheme = function deleteTheme(theme) {
  return {
    type: constants.DELETE_THEME,
    theme: theme
  };
};
var deleteThemes = exports.deleteThemes = function deleteThemes() {
  return {
    type: constants.DELETE_THEMES
  };
};
});
unwrapExports(actions);
var actions_1 = actions.deleteThemes;
var actions_2 = actions.deleteTheme;
var actions_3 = actions.storeTheme;
var actions_4 = actions.changeTheme;

var _extends$2 = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

function makeLoadTheme(themeProvider) {
  return (             regeneratorRuntime.mark(function loadTheme(action) {
      var theme;
      return regeneratorRuntime.wrap(function loadTheme$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return call(themeProvider, action.name);
            case 3:
              theme = _context.sent;
              _context.next = 6;
              return put(actions_4(_extends$2({}, theme, { _async: true, _loaded: true })));
            case 6:
              _context.next = 12;
              break;
            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](0);
              _context.next = 12;
              return put(changeThemeFailure(action.name, _context.t0));
            case 12:
            case 'end':
              return _context.stop();
          }
        }
      }, loadTheme, this, [[0, 8]]);
    })
  );
}

export { changeThemeRequest, changeThemeFailure, storeAsyncTheme, deleteAsyncThemes, CHANGE_THEME_REQUEST, CHANGE_THEME_FAILURE, DELETE_ASYNC_THEMES, STORE_ASYNC_THEME, makeLoadTheme };
//# sourceMappingURL=saga.es.js.map
