'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteAsyncThemes = exports.storeAsyncTheme = exports.changeThemeFailure = exports.changeThemeRequest = undefined;

var _constants = require('./constants');

/**
 * trigger to use change async theme
 * @param name
 */
var changeThemeRequest = exports.changeThemeRequest = function changeThemeRequest(name) {
  return {
    type: _constants.CHANGE_THEME_REQUEST,
    name: name
  };
};

/**
 * changeTheme failure
 * @param current
 * @param error
 */
var changeThemeFailure = exports.changeThemeFailure = function changeThemeFailure(current, error) {
  return {
    type: _constants.CHANGE_THEME_FAILURE,
    error: error,
    current: current
  };
};

/**
 * store async theme in store
 */
var storeAsyncTheme = exports.storeAsyncTheme = function storeAsyncTheme(theme) {
  return {
    type: _constants.STORE_ASYNC_THEME,
    theme: theme
  };
};

/**
 * delete all async themes in store
 */
var deleteAsyncThemes = exports.deleteAsyncThemes = function deleteAsyncThemes() {
  return {
    type: _constants.DELETE_ASYNC_THEMES
  };
};