'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeProps = exports.mapDispatchToProps = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactRedux = require('react-redux');

var _Toggle = require('@bootstrap-styled/toggle/lib/components/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _reselect = require('reselect');

var _actions = require('@bootstrap-styled/redux/lib/actions');

var _selectors = require('@bootstrap-styled/redux/lib/selectors');

var _selectors2 = require('../../selectors');

var _actions2 = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var mapStateToProps = (0, _reselect.createStructuredSelector)({
  /** we pick the actual value from bootstrap-styled-redux */
  value: _selectors.selectValue,
  /** we use a special selector that group values of both store */
  values: _selectors2.selectGroupedValues,
  /** we need to map the async themes here otherwise we cannot filter and know which key come from the async store. */
  asyncThemes: _selectors2.selectAsyncThemes
});

var mapDispatchToProps = exports.mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return { dispatch: dispatch };
};

/* eslint-disable no-underscore-dangle, no-plusplus, no-cond-assign */
var mergeProps = function mergeProps(_ref, _ref2) {
  var dispatch = _ref2.dispatch,
      dispatchProps = _objectWithoutProperties(_ref2, ['dispatch']);

  var asyncThemes = _ref.asyncThemes,
      stateProps = _objectWithoutProperties(_ref, ['asyncThemes']);

  return _extends({}, stateProps, dispatchProps, {
    onToggle: function onToggle(evt) {
      var asyncKey = false;
      var key = void 0;
      var keys = Object.keys(asyncThemes);
      while (key = keys.shift()) {
        if (key === evt.target.value) {
          asyncKey = true;
          break;
        }
      }
      return dispatch(asyncKey ? (0, _actions2.changeThemeRequest)(evt.target.value) : (0, _actions.changeTheme)(evt.target.value));
    }
  });
};

/**
 * AllThemeToggle will display sync and unsync theme
 * @constructor
 */
exports.mergeProps = mergeProps;
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps)(_Toggle2.default);