'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _enzyme = require('enzyme');

var _redux = require('redux');

var _theme = require('bootstrap-styled/lib/theme');

var _theme2 = _interopRequireDefault(_theme);

var _actions = require('@bootstrap-styled/redux/lib/actions');

var _reducer = require('../../../reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _actions2 = require('../../../actions');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _themeProvider = require('../../../../styleguide/components/tests/themeProvider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable function-paren-newline, no-underscore-dangle */
describe('<AsyncThemeToggle />', function () {
  var store = void 0;
  beforeAll(function () {
    store = (0, _redux.createStore)(_reducer2.default, {
      'bs.redux': {
        theme: _theme2.default,
        themes: _defineProperty({}, _theme2.default._name + '-pink-async', (0, _theme.makeTheme)({
          _name: _theme2.default._name + '-pink-async',
          '$btn-primary-bg': 'pink'
        }))
      },
      'bs.saga': {
        themes: _themeProvider.themes
      }
    });
  });

  it('should render the default language messages', function () {
    var renderedComponent = (0, _enzyme.mount)(_react2.default.createElement(
      _reactRedux.Provider,
      { store: store },
      _react2.default.createElement(_index2.default, null)
    ));
    expect(renderedComponent.contains(_react2.default.createElement(_index2.default, null))).toBe(true);
  });

  describe('mapDispatchToProps', function () {
    describe('dispatch', function () {
      var dispatchProps = void 0;
      var dispatch = void 0;

      it('should be injected', function () {
        dispatch = jest.fn();
        dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
        expect(dispatchProps.dispatch).toBeDefined();
      });

      describe('mergeProps', function () {
        var stateProps = void 0;
        var mergedProps = void 0;

        beforeAll(function () {
          dispatch = jest.fn();
          stateProps = {
            asyncThemes: _themeProvider.themes
          };
        });

        it('should dispatch onToggle async when called', function () {
          dispatch = jest.fn();
          dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
          mergedProps = (0, _index.mergeProps)(stateProps, dispatchProps);
          var evt = { target: { value: Object.keys(_themeProvider.themes)[0] } };
          mergedProps.onToggle(evt);
          expect(dispatch).toHaveBeenCalledWith((0, _actions2.changeThemeRequest)(Object.keys(_themeProvider.themes)[0]));
        });

        it('should dispatch onToggle sync when called', function () {
          dispatch = jest.fn();
          var newTheme = _extends({}, _theme2.default, { _name: 'edited', _async: true });
          dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
          mergedProps = (0, _index.mergeProps)(stateProps, dispatchProps);
          var evt = { target: { value: newTheme._name } };
          mergedProps.onToggle(evt);
          expect(dispatch).toHaveBeenCalledWith((0, _actions.changeTheme)(newTheme._name));
        });
      });
    });
  });
});