'use strict';

var _asyncThemeReducer = require('../asyncThemeReducer');

var _asyncThemeReducer2 = _interopRequireDefault(_asyncThemeReducer);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('asyncThemeReducer', function () {
  var state = void 0;
  var expectedResult = void 0;

  beforeEach(function () {
    state = _asyncThemeReducer.initialState;
    expectedResult = undefined;
  });

  it('should return the initial state', function () {
    expectedResult = state;
    expect((0, _asyncThemeReducer2.default)(undefined, {})).toEqual(expectedResult);
  });

  it('should handle the deleteAsyncThemes action correctly', function () {
    expectedResult = {
      themes: {}
    };
    expect((0, _asyncThemeReducer2.default)(state, (0, _actions.deleteAsyncThemes)())).toEqual(expectedResult);
  });

  it('should handle the storeAsyncTheme action correctly', function () {
    var theme = {
      _name: 'test',
      $white: '#eee'
    };
    expectedResult = {
      themes: _defineProperty({}, theme._name, theme)
    };
    expect((0, _asyncThemeReducer2.default)(state, (0, _actions.storeAsyncTheme)(theme))).toEqual(expectedResult);
  });
});