'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.makeLoadTheme = makeLoadTheme;

var _effects = require('redux-saga/effects');

var _actions = require('@bootstrap-styled/redux/lib/actions');

var _constants = require('./constants');

var _actions2 = require('./actions');

/* eslint-disable no-underscore-dangle, no-param-reassign */
function makeLoadTheme(themeProvider) {
  return (/*#__PURE__*/regeneratorRuntime.mark(function loadTheme(action) {
      var theme;
      return regeneratorRuntime.wrap(function loadTheme$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return (0, _effects.call)(themeProvider, action.name);

            case 3:
              theme = _context.sent;
              _context.next = 6;
              return (0, _effects.put)((0, _actions.changeTheme)(_extends({}, theme, { _async: true, _loaded: true })));

            case 6:
              _context.next = 12;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](0);
              _context.next = 12;
              return (0, _effects.put)((0, _actions2.changeThemeFailure)(action.name, _context.t0));

            case 12:
            case 'end':
              return _context.stop();
          }
        }
      }, loadTheme, this, [[0, 8]]);
    })
  );
}

/**
 * This is the saga responsible of initializing the store for async themes
 * @param themeProvider
 * @param themes = either an object of named theme, or an array of names
 * clean: will erases themes stored in bootstrap-styled-redux.
 * persist: async theme will be left in stored when the theme a second times.
 */

exports.default = function (themeProvider, themes) {
  return (/*#__PURE__*/regeneratorRuntime.mark(function makeBootstrapStyledSaga() {
      var keys;
      return regeneratorRuntime.wrap(function makeBootstrapStyledSaga$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // this will allow user to pass array of names or just the themes object
              keys = themes instanceof Array ? themes : Object.keys(themes);

              // initialize our saga

              _context2.next = 3;
              return (0, _effects.all)([(0, _effects.takeLatest)(_constants.CHANGE_THEME_REQUEST, makeLoadTheme(themeProvider))].concat(keys.map(function (key) {
                return (0, _effects.put)((0, _actions2.storeAsyncTheme)({ _name: key, _async: true, _loaded: false }));
              })));

            case 3:
            case 'end':
              return _context2.stop();
          }
        }
      }, makeBootstrapStyledSaga, this);
    })
  );
};