'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.selectGroupedValues = exports.selectGroupedThemes = exports.selectAsyncValues = exports.selectAsyncThemes = exports.selectBsSaga = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reselect = require('reselect');

var selectBsSaga = exports.selectBsSaga = function selectBsSaga(state) {
  return state['bs.saga'];
};

/**
 * themes
 */
var selectAsyncThemes = exports.selectAsyncThemes = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return bsSagaState.themes;
});

/**
 * async theme values
 */
var selectAsyncValues = exports.selectAsyncValues = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return Object.keys(bsSagaState.themes);
});

/**
 * async all themes
 */
var selectGroupedThemes = exports.selectGroupedThemes = (0, _reselect.createSelector)(function (state) {
  return { sagaState: state['bs.saga'], reduxState: state['bs.redux'] };
}, function (tmpState) {
  return _extends({}, tmpState.reduxState.themes, tmpState.sagaState.themes);
});

/**
 * async all theme values
 */
var selectGroupedValues = exports.selectGroupedValues = (0, _reselect.createSelector)(function (state) {
  return { sagaState: state['bs.saga'], reduxState: state['bs.redux'] };
}, function (tmpState) {
  return Object.keys(tmpState.sagaState.themes).concat(Object.keys(tmpState.reduxState.themes));
});